diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
index ecbc1c78a..a6ea92d5a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
@@ -13,9 +13,10 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class TileEntity implements ICarriable
+public abstract class TileEntity implements ICarriable
 {
     public @Nullable World worldObj; // Null when loading data from nbt and null when held by entity
     public @Nullable CarriedBlock carriedBlock;
@@ -94,14 +95,17 @@ public class TileEntity implements ICarriable
         tileEntityInvalid = false;
     }
 
-    public void readFromNBT(CompoundTag nbttagcompound)
+    public final void readFromNBT(@NotNull CompoundTag compoundTag)
     {
-        x = nbttagcompound.getInteger("x");
-        y = nbttagcompound.getInteger("y");
-        z = nbttagcompound.getInteger("z");
+        x = compoundTag.getInteger("x");
+        y = compoundTag.getInteger("y");
+        z = compoundTag.getInteger("z");
+        readAdditionalData(compoundTag);
     }
 
-    public void writeToNBT(CompoundTag nbttagcompound)
+    public abstract void readAdditionalData(@NotNull CompoundTag compoundTag);
+
+    public final void writeToNBT(@NotNull CompoundTag compoundTag)
     {
         NamespaceID name = TileEntityDispatcher.getIDFromClass(getClass());
         if(name == null)
@@ -109,13 +113,16 @@ public class TileEntity implements ICarriable
             throw new RuntimeException(getClass() + " is missing a mapping! This is a bug!");
         } else
         {
-            nbttagcompound.putString("id", name.toString());
-            nbttagcompound.putInt("x", x);
-            nbttagcompound.putInt("y", y);
-            nbttagcompound.putInt("z", z);
+            compoundTag.putString("id", name.toString());
+            compoundTag.putInt("x", x);
+            compoundTag.putInt("y", y);
+            compoundTag.putInt("z", z);
+            writeAdditionalData(compoundTag);
         }
     }
 
+    public abstract void writeAdditionalData(@NotNull CompoundTag compoundTag);
+
     @Override
     public void heldTick(World world, Entity holder) {
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
index cdcd2ebd8..5b20fdef6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
@@ -12,6 +12,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -135,9 +136,8 @@ public class TileEntityActivator extends TileEntity implements Container {
     }
 
     @Override
-    public void readFromNBT(CompoundTag compoundTag)
+    public void readAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.readFromNBT(compoundTag);
         stackSelector = compoundTag.getByte("Selector");
         lockedSlotBitSet = compoundTag.getShort("LockedSlots");
         ListTag itemListTag = compoundTag.getList("Items");
@@ -155,9 +155,8 @@ public class TileEntityActivator extends TileEntity implements Container {
     }
 
     @Override
-    public void writeToNBT(CompoundTag compoundTag)
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.writeToNBT(compoundTag);
         compoundTag.putByte("Selector", (byte) stackSelector);
         compoundTag.putShort("LockedSlots", lockedSlotBitSet);
         ListTag itemListTag = new ListTag();
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
index 13e4abeb3..f0e75173d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
@@ -14,6 +14,7 @@ import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketTileEntityData;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public class TileEntityBasket extends TileEntity
 {
@@ -103,10 +104,8 @@ public class TileEntityBasket extends TileEntity
 	}
 
     @Override
-    public void readFromNBT(final CompoundTag tag)
-    {
-        super.readFromNBT(tag);
-        final ListTag itemsTag = tag.getList("Items");
+    public void readAdditionalData(@NotNull CompoundTag compoundTag) {
+        final ListTag itemsTag = compoundTag.getList("Items");
         contents.clear();
         for (int i = 0; i < itemsTag.tagCount(); i++)
         {
@@ -186,9 +185,8 @@ public class TileEntityBasket extends TileEntity
     }
 
     @Override
-    public void writeToNBT(final CompoundTag tag)
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.writeToNBT(tag);
         final ListTag itemsTag = new ListTag();
         for (Map.Entry<BasketEntry, Integer> entry : contents.entrySet())
         {
@@ -198,7 +196,7 @@ public class TileEntityBasket extends TileEntity
             itemsTag.addTag(itemTag);
         }
 
-        tag.put("Items", itemsTag);
+        compoundTag.put("Items", itemsTag);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
index 3c7504611..e1555e48e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
@@ -14,6 +14,7 @@ import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.player.inventory.InventorySorter;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 public class TileEntityChest extends TileEntity
@@ -81,10 +82,9 @@ public class TileEntityChest extends TileEntity
     }
 
     @Override
-	public void readFromNBT(CompoundTag nbttagcompound)
+    public void readAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.readFromNBT(nbttagcompound);
-        ListTag nbttaglist = nbttagcompound.getList("Items");
+        ListTag nbttaglist = compoundTag.getList("Items");
         chestContents = new ItemStack[getContainerSize()];
         for(int i = 0; i < nbttaglist.tagCount(); i++)
         {
@@ -98,9 +98,8 @@ public class TileEntityChest extends TileEntity
     }
 
     @Override
-	public void writeToNBT(CompoundTag nbttagcompound)
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.writeToNBT(nbttagcompound);
         ListTag nbttaglist = new ListTag();
         for(int i = 0; i < chestContents.length; i++)
         {
@@ -113,7 +112,7 @@ public class TileEntityChest extends TileEntity
             }
         }
 
-        nbttagcompound.put("Items", nbttaglist);
+        compoundTag.put("Items", nbttaglist);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
index cb993fea7..d36da668a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
@@ -13,6 +13,7 @@ import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -112,10 +113,9 @@ public class TileEntityDispenser extends TileEntity
     }
 
     @Override
-	public void readFromNBT(CompoundTag nbttagcompound)
+	public void readAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.readFromNBT(nbttagcompound);
-        ListTag nbttaglist = nbttagcompound.getList("Items");
+        ListTag nbttaglist = compoundTag.getList("Items");
         dispenserContents = new ItemStack[getContainerSize()];
         for(int i = 0; i < nbttaglist.tagCount(); i++)
         {
@@ -130,9 +130,8 @@ public class TileEntityDispenser extends TileEntity
     }
 
     @Override
-	public void writeToNBT(CompoundTag nbttagcompound)
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.writeToNBT(nbttagcompound);
         ListTag nbttaglist = new ListTag();
         for(int i = 0; i < dispenserContents.length; i++)
         {
@@ -145,7 +144,7 @@ public class TileEntityDispenser extends TileEntity
             }
         }
 
-        nbttagcompound.put("Items", nbttaglist);
+        compoundTag.put("Items", nbttaglist);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
index e28a08896..9aab9595a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
@@ -13,6 +13,7 @@ import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketTileEntityData;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.UUIDHelper;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class TileEntityFlag extends TileEntity
@@ -74,17 +75,11 @@ public class TileEntityFlag extends TileEntity
     }
 
     @Override
-    public void writeToNBT(CompoundTag tag) {
-        super.writeToNBT(tag);
-        writeFlagNBT(tag);
-    }
-    
-    public void writeFlagNBT(CompoundTag tag)
-    {
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag) {
         byte[] packedColors = packFlagColors(flagColors);
-        tag.putByteArray("Colors", packedColors);
-        UUIDHelper.writeToTag(tag, owner, "OwnerUUID");
-        tag.putBoolean("Flip", flipped);
+        compoundTag.putByteArray("Colors", packedColors);
+        UUIDHelper.writeToTag(compoundTag, owner, "OwnerUUID");
+        compoundTag.putBoolean("Flip", flipped);
 
         ListTag list = new ListTag();
         for (int i = 0; i < items.length; i++)
@@ -97,19 +92,13 @@ public class TileEntityFlag extends TileEntity
                 list.addTag(compound);
             }
         }
-        tag.putList("Items", list);
+        compoundTag.putList("Items", list);
     }
 
     @Override
-    public void readFromNBT(CompoundTag tag)
-    {
-        super.readFromNBT(tag);
-        readFlagNBT(tag);
-    }
-    
-    public void readFlagNBT(CompoundTag tag)
+    public void readAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        byte[] packedColors = tag.getByteArrayOrDefault("Colors", null);
+        byte[] packedColors = compoundTag.getByteArrayOrDefault("Colors", null);
         if (packedColors == null) packedColors = new byte[(CANVAS_WIDTH * CANVAS_HEIGHT) / 4];
         byte[] unpackedColors = unpackFlagColors(packedColors);
         System.arraycopy(unpackedColors, 0, flagColors, 0, CANVAS_WIDTH * CANVAS_HEIGHT);
@@ -119,9 +108,9 @@ public class TileEntityFlag extends TileEntity
             colorHash ^= flagColors[i] << (8 * (i & 0b11));
         }
 
-        UUID ownerUUID = UUIDHelper.readFromTag(tag, "OwnerUUID");
+        UUID ownerUUID = UUIDHelper.readFromTag(compoundTag, "OwnerUUID");
         if (ownerUUID == null) {
-            String s = tag.getString("Owner");
+            String s = compoundTag.getString("Owner");
             if (!s.isEmpty()) {
                 UUIDHelper.runConversionAction(s,
                     (uuid) -> this.owner = uuid,
@@ -131,9 +120,9 @@ public class TileEntityFlag extends TileEntity
             this.owner = ownerUUID;
         }
 
-        flipped = tag.getBooleanOrDefault("Flip", false);
+        flipped = compoundTag.getBooleanOrDefault("Flip", false);
 
-        ListTag list = tag.getList("Items");
+        ListTag list = compoundTag.getList("Items");
         items = new ItemStack[getContainerSize()];
         for (int i = 0; i < list.tagCount(); i++)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
index 6b1995c3a..2f86a3967 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
@@ -9,6 +9,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketTileEntityData;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public class TileEntityFlowerJar extends TileEntity {
 
@@ -16,18 +17,16 @@ public class TileEntityFlowerJar extends TileEntity {
     public int flowerData;
 
     @Override
-    public void readFromNBT(CompoundTag tag) {
-        super.readFromNBT(tag);
-        flowerInPot = tag.getInteger("PlantedId");
-        flowerData = Byte.toUnsignedInt(tag.getByteOrDefault("PlantedData", (byte) 0));
+    public void readAdditionalData(@NotNull CompoundTag compoundTag) {
+        flowerInPot = compoundTag.getInteger("PlantedId");
+        flowerData = Byte.toUnsignedInt(compoundTag.getByteOrDefault("PlantedData", (byte) 0));
     }
 
     @Override
-    public void writeToNBT(CompoundTag tag) {
-        super.writeToNBT(tag);
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag) {
         if (flowerInPot > 0) {
-            tag.putInt("PlantedId", flowerInPot);
-            tag.putByte("PlantedData", (byte) flowerData);
+            compoundTag.putInt("PlantedId", flowerInPot);
+            compoundTag.putByte("PlantedData", (byte) flowerData);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
index 154efaccd..2793f0879 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
@@ -19,6 +19,7 @@ import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.List;
 import java.util.Random;
@@ -99,10 +100,9 @@ public class TileEntityFurnace extends TileEntity
     }
 
     @Override
-	public void readFromNBT(CompoundTag nbttagcompound)
+	public void readAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.readFromNBT(nbttagcompound);
-        ListTag nbttaglist = nbttagcompound.getList("Items");
+        ListTag nbttaglist = compoundTag.getList("Items");
         furnaceItemStacks = new ItemStack[getContainerSize()];
         for(int i = 0; i < nbttaglist.tagCount(); i++)
         {
@@ -114,18 +114,17 @@ public class TileEntityFurnace extends TileEntity
             }
         }
 
-        currentBurnTime = nbttagcompound.getShort("BurnTime");
-        currentCookTime = nbttagcompound.getShort("CookTime");
-        maxBurnTime = nbttagcompound.getShort("MaxBurnTime");
+        currentBurnTime = compoundTag.getShort("BurnTime");
+        currentCookTime = compoundTag.getShort("CookTime");
+        maxBurnTime = compoundTag.getShort("MaxBurnTime");
     }
 
     @Override
-	public void writeToNBT(CompoundTag nbttagcompound)
+	public void writeAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.writeToNBT(nbttagcompound);
-        nbttagcompound.putShort("BurnTime", (short) currentBurnTime);
-        nbttagcompound.putShort("CookTime", (short) currentCookTime);
-        nbttagcompound.putShort("MaxBurnTime", (short) maxBurnTime);
+        compoundTag.putShort("BurnTime", (short) currentBurnTime);
+        compoundTag.putShort("CookTime", (short) currentCookTime);
+        compoundTag.putShort("MaxBurnTime", (short) maxBurnTime);
         ListTag nbttaglist = new ListTag();
         for(int i = 0; i < furnaceItemStacks.length; i++)
         {
@@ -138,7 +137,7 @@ public class TileEntityFurnace extends TileEntity
             }
         }
 
-        nbttagcompound.put("Items", nbttaglist);
+        compoundTag.put("Items", nbttaglist);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
index 44f078335..07e248c08 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
@@ -9,6 +9,7 @@ import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryBlastFurnace;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.List;
 
@@ -29,49 +30,6 @@ public class TileEntityFurnaceBlast extends TileEntityFurnace
         return "container.furnace_blast.name";
     }
 
-    @Override
-	public void readFromNBT(CompoundTag nbttagcompound)
-    {
-        super.readFromNBT(nbttagcompound);
-        ListTag nbttaglist = nbttagcompound.getList("Items");
-        furnaceItemStacks = new ItemStack[getContainerSize()];
-        for(int i = 0; i < nbttaglist.tagCount(); i++)
-        {
-            CompoundTag nbttagcompound1 = (CompoundTag)nbttaglist.tagAt(i);
-            byte byte0 = nbttagcompound1.getByte("Slot");
-            if(byte0 >= 0 && byte0 < furnaceItemStacks.length)
-            {
-                furnaceItemStacks[byte0] = ItemStack.readItemStackFromNbt(nbttagcompound1);
-            }
-        }
-
-        currentBurnTime = nbttagcompound.getShort("BurnTime");
-        currentCookTime = nbttagcompound.getShort("CookTime");
-        maxBurnTime = nbttagcompound.getShort("MaxBurnTime");
-    }
-
-    @Override
-	public void writeToNBT(CompoundTag nbttagcompound)
-    {
-        super.writeToNBT(nbttagcompound);
-        nbttagcompound.putShort("BurnTime", (short) currentBurnTime);
-        nbttagcompound.putShort("CookTime", (short) currentCookTime);
-        nbttagcompound.putShort("MaxBurnTime", (short) maxBurnTime);
-        ListTag nbttaglist = new ListTag();
-        for(int i = 0; i < furnaceItemStacks.length; i++)
-        {
-            if(furnaceItemStacks[i] != null)
-            {
-                CompoundTag itemStackAtSlot = new CompoundTag();
-                itemStackAtSlot.putByte("Slot", (byte)i);
-                furnaceItemStacks[i].writeToNBT(itemStackAtSlot);
-                nbttaglist.addTag(itemStackAtSlot);
-            }
-        }
-
-        nbttagcompound.put("Items", nbttaglist);
-    }
-
     @Override
 	public void tick()
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJarButterfly.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJarButterfly.java
index b7f10d695..77121d8e1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJarButterfly.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJarButterfly.java
@@ -2,6 +2,7 @@ package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.animal.MobButterfly;
+import org.jetbrains.annotations.NotNull;
 
 public class TileEntityJarButterfly extends TileEntity{
     public MobButterfly.ButterflyEntry color;
@@ -25,14 +26,12 @@ public class TileEntityJarButterfly extends TileEntity{
     }
 
     @Override
-    public void readFromNBT(CompoundTag compoundTag) {
-        super.readFromNBT(compoundTag);
+    public void readAdditionalData(@NotNull CompoundTag compoundTag) {
         color = MobButterfly.colorEntries.getOrDefault(compoundTag.getByte("color") & 0xFF, MobButterfly.COLOR_BLUE);
     }
 
     @Override
-    public void writeToNBT(CompoundTag compoundTag) {
-        super.writeToNBT(compoundTag);
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag) {
         compoundTag.putByte("color", (byte) color.id);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
index 899b505d3..8151eceaf 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
@@ -7,6 +7,7 @@ import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.save.conversion.ChunkConverter;
 import com.mojang.nbt.tags.CompoundTag;
+import org.jetbrains.annotations.NotNull;
 
 public class TileEntityJukebox extends TileEntity {
     public int record;
@@ -14,10 +15,9 @@ public class TileEntityJukebox extends TileEntity {
     }
 
     @Override
-	public void readFromNBT(CompoundTag nbttagcompound) {
-        super.readFromNBT(nbttagcompound);
-        record = nbttagcompound.getInteger("Record");
-        byte expanded = nbttagcompound.getByte("Expanded");
+    public void readAdditionalData(@NotNull CompoundTag compoundTag) {
+        record = compoundTag.getInteger("Record");
+        byte expanded = compoundTag.getByte("Expanded");
         if (expanded == 0 && record >= 256) {
             record += (Blocks.blocksList.length - 256);
         }
@@ -30,11 +30,10 @@ public class TileEntityJukebox extends TileEntity {
     }
 
     @Override
-	public void writeToNBT(CompoundTag nbttagcompound) {
-        super.writeToNBT(nbttagcompound);
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag) {
         if (record > 0) {
-            nbttagcompound.putInt("Record", record);
-            nbttagcompound.putByte("Expanded", (byte) 1);
+            compoundTag.putInt("Record", record);
+            compoundTag.putByte("Expanded", (byte) 1);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
index 9e1882d97..c31b65acb 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
@@ -7,6 +7,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketTileEntityData;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class TileEntityMeshGold extends TileEntity {
@@ -45,9 +46,8 @@ public class TileEntityMeshGold extends TileEntity {
         return success | !wasNull;
     }
     @Override
-    public void readFromNBT(CompoundTag compoundTag)
+    public void readAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.readFromNBT(compoundTag);
         if (compoundTag.getBoolean("hasItem")){
             filterItem = ItemStack.readItemStackFromNbt(compoundTag.getCompound("item"));
         } else {
@@ -56,9 +56,8 @@ public class TileEntityMeshGold extends TileEntity {
     }
 
     @Override
-    public void writeToNBT(CompoundTag compoundTag)
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.writeToNBT(compoundTag);
         if (filterItem != null){
             compoundTag.putCompound("item", filterItem.writeToNBT(new CompoundTag()));
             compoundTag.putBoolean("hasItem", true);
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
index ff1e5da00..79bd83c8b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
@@ -8,6 +8,7 @@ import net.minecraft.core.util.phys.AABB;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketSetMobSpawner;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 public class TileEntityMobSpawner extends TileEntity
@@ -171,19 +172,17 @@ public class TileEntityMobSpawner extends TileEntity
     }
 
     @Override
-	public void readFromNBT(CompoundTag tag)
+    public void readAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.readFromNBT(tag);
-        setMobId(tag.getString("EntityId"));
-        delay = tag.getShort("Delay");
+        setMobId(compoundTag.getString("EntityId"));
+        delay = compoundTag.getShort("Delay");
     }
 
     @Override
-	public void writeToNBT(CompoundTag tag)
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.writeToNBT(tag);
-        tag.putString("EntityId", mobId != null ? mobId : "none");
-        tag.putShort("Delay", (short)delay);
+        compoundTag.putString("EntityId", mobId != null ? mobId : "none");
+        compoundTag.putShort("Delay", (short)delay);
     }
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java
index df4e9b66d..29dfd3d60 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java
@@ -4,6 +4,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.BlockLogicNote;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 
 @Deprecated
 public class TileEntityNoteblock extends TileEntity
@@ -25,15 +26,13 @@ public class TileEntityNoteblock extends TileEntity
     }
 
     @Override
-	public void writeToNBT(CompoundTag tag) {
-        super.writeToNBT(tag);
-        tag.putByte("note", note);
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag) {
+        compoundTag.putByte("note", note);
     }
 
     @Override
-	public void readFromNBT(CompoundTag tag) {
-        super.readFromNBT(tag);
-        note = MathHelper.clamp(tag.getByte("note"), (byte) 0, BlockLogicNote.MAX_NOTE);
+    public void readAdditionalData(@NotNull CompoundTag compoundTag) {
+        note = MathHelper.clamp(compoundTag.getByte("note"), (byte) 0, BlockLogicNote.MAX_NOTE);
     }
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
index 62d64220e..c89a1f0d9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
@@ -7,6 +7,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
 import com.mojang.nbt.tags.CompoundTag;
+import org.jetbrains.annotations.NotNull;
 
 public class TileEntitySeat
     extends TileEntity
@@ -138,18 +139,16 @@ public class TileEntitySeat
     }
 
     @Override
-    public void writeToNBT(CompoundTag compoundTag)
+    public void writeAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.writeToNBT(compoundTag);
         if (seat != null && seat != Blocks.SEAT) {
             compoundTag.putInt("Block", seat.id());
         }
     }
 
     @Override
-    public void readFromNBT(CompoundTag compoundTag)
+    public void readAdditionalData(@NotNull CompoundTag compoundTag)
     {
-        super.readFromNBT(compoundTag);
         seat = Blocks.getBlock(compoundTag.getIntegerOrDefault("Block", Blocks.SEAT.id()));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
index a699744a0..5b07d71ad 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
@@ -2,6 +2,7 @@ package net.minecraft.core.block.entity;
 
 import java.util.List;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.BlockLogicMotionSensor;
@@ -13,6 +14,7 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public class TileEntitySensor extends TileEntity {
 
@@ -94,6 +96,16 @@ public class TileEntitySensor extends TileEntity {
 		}
 	}
 
+	@Override
+	public void readAdditionalData(@NotNull CompoundTag compoundTag) {
+
+	}
+
+	@Override
+	public void writeAdditionalData(@NotNull CompoundTag compoundTag) {
+
+	}
+
 	@Override
 	public void heldTick(World world, Entity holder) {
 		if(world == null || carriedBlock == null || world.isClientSide) {
